"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var jszip_1 = __importDefault(require("jszip"));
var services_1 = require("@jupyterlab/services");
function createFSK(metadata, modelscript, visualscript, supplement, xlsxmetadata, parameterfile) {
    return __awaiter(this, void 0, void 0, function () {
        var zip, manifestXML, RDFMetadata, data, index, SEDMLsim, index, SEDMLmodel, defaultSimulation, index, index, img;
        return __generator(this, function (_a) {
            zip = new jszip_1.default();
            manifestXML = '<?xml version="1.0" encoding="UTF-8"?>\n';
            manifestXML += '<omexManifest xmlns="http://identifiers.org/combine.specifications/omex-manifest">';
            manifestXML += '<content location="." format="http://identifiers.org/combine.specifications/omex" />\n';
            manifestXML += '<content location="./manifest.xml" format="http://identifiers.org/combine.specifications/omex-manifest" />\n';
            RDFMetadata = '<?xml version="1.0" encoding="UTF-8"?>\n';
            RDFMetadata += '<rdf:RDF xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#" xmlns:dcterms="http://purl.org/dc/terms/" xmlns:vCard="http://www.w3.org/2006/vcard/ns#">\n';
            RDFMetadata += '<rdf:Description rdf:about=".">\n<dcterms:conformsTo>2.0</dcterms:conformsTo>\n</rdf:Description>\n';
            data = metadata;
            data.generalInformation.creationDate = "2019-05-14T22:00:00";
            for (index = 0; index < data.modelMath.parameter.length; index++) {
                //data.modelMath.parameter[index].classification = data.modelMath.parameter[index].classification.toLowerCase();
                //data.modelMath.parameter[index].dataType = data.modelMath.parameter[index].dataType.charAt(0).toUpperCase() + data.modelMath.parameter[index].dataType.slice(1).toLowerCase();
            }
            console.log("MetaDATA", data);
            zip.file("metaData.json", JSON.stringify(data));
            manifestXML += '<content format="https://www.iana.org/assignments/media-types/application/json" location="./metaData.json" />\n';
            SEDMLsim = '<?xml version="1.0" encoding="UTF-8"?>\n<sedML xmlns="http://sed-ml.org/" xmlns:math="http://www.w3.org/1998/Math/MathML" level="1" version="1">\n<annotation>\n<SelectedSimulation>0</SelectedSimulation>\n</annotation>\n';
            SEDMLsim += '<listOfSimulations>\n<steadyState id="steadyState" name="">\n<annotation>\n<sourceScript language="https://iana.org/assignments/mediatypes/text/x-r" src="./simulations/defaultSimulation.R" />\n</annotation>\n<algorithm kisaoID=" " />\n</steadyState>\n</listOfSimulations>\n';
            SEDMLsim += '<listOfModels>\n';
            SEDMLsim += '<model id="defaultSimulation" name="" language="https://iana.org/assignments/mediatypes/text/x-r" source="./model.r">\n';
            SEDMLsim += '<listOfChanges>\n';
            for (index = 0; index < data.modelMath.parameter.length; index++) {
                SEDMLsim += '<changeAttribute newValue="' + data.modelMath.parameter[index].value + '" target="' + data.modelMath.parameter[index].id + '" />\n';
            }
            SEDMLsim += '</listOfChanges>\n';
            SEDMLsim += '</model>\n';
            SEDMLsim += '</listOfModels>\n';
            SEDMLsim += '<listOfTasks>\n';
            SEDMLsim += '<task id="task0" name="" modelReference="defaultSimulation" simulationReference="steadyState" />\n';
            SEDMLsim += '</listOfTasks>\n';
            SEDMLsim += '<listOfDataGenerators />\n';
            SEDMLsim += '<listOfOutputs>\n';
            SEDMLsim += '<plot2D id="plot1" name="">\n';
            SEDMLsim += '<annotation>\n';
            SEDMLsim += '<sourceScript language="https://iana.org/assignments/mediatypes/text/x-r" src="./visualization.r" />\n';
            SEDMLsim += '</annotation>\n';
            SEDMLsim += '</plot2D>\n';
            SEDMLsim += '</listOfOutputs>\n';
            SEDMLsim += '</sedML>\n';
            zip.file("sim.sedml", SEDMLsim);
            SEDMLmodel = '<?xml version="1.0" encoding="UTF-8" standalone="no"?>\n<sbml xmlns="http://www.sbml.org/sbml/level3/version1/core" xmlns:fsk="https://foodrisklabs.bfr.bund.de/wp-content/uploads/2017/01/FSK-ML_guidance_document_021216.pdf" level="3" version="1">\n';
            SEDMLmodel += '<model id="model">\n<listOfParameters>\n';
            defaultSimulation = "";
            for (index = 0; index < data.modelMath.parameter.length; index++) {
                if (data.generalInformation.languageWrittenIn === "R") {
                    defaultSimulation += data.modelMath.parameter[index].id + " <- " + data.modelMath.parameter[index].value + "\n";
                }
                else {
                    defaultSimulation += data.modelMath.parameter[index].id + " = " + data.modelMath.parameter[index].value + "\n";
                }
                SEDMLmodel += '<parameter constant="' + data.modelMath.parameter[index].classification.toLowerCase() + '" id="' + data.modelMath.parameter[index].id + '">\n';
                if (data.modelMath.parameter[index].id != "") {
                    SEDMLmodel += '<annotation>\n<fsk:parameter value="' + data.modelMath.parameter[index].value + '"/>\n</annotation>\n';
                }
                SEDMLmodel += '</parameter>\n';
            }
            SEDMLmodel += '</listOfParameters>\n</model>\n</sbml>\n';
            zip.file("model.sbml", SEDMLmodel);
            //if metadata in xlsx format
            if (xlsxmetadata) {
                zip.file("metadata.xlsx", xlsxmetadata);
                manifestXML += '<content location="./metadata.xlsx" format="https://www.iana.org/assignments/media-types/application/vdn.ms-excel" />\n';
            }
            //Create model file
            zip.file("model.r", modelscript);
            manifestXML += '<content location="./model.r" format="http://purl.org/NET/mediatypes/application/r" />\n';
            RDFMetadata += '<rdf:Description rdf:about="/model.r">\n<dc:type xmlns:dc="http://purl.org/dc/elements/1.1/">modelScript</dc:type>\n</rdf:Description>\n';
            //Create Visualization file
            zip.file("visualization.r", visualscript);
            manifestXML += '<content location="./visualization.r" format="http://purl.org/NET/mediatypes/application/r" />\n';
            RDFMetadata += '<rdf:Description rdf:about="/visualization.r">\n<dc:type xmlns:dc="http://purl.org/dc/elements/1.1/">visualizationScript</dc:type>\n</rdf:Description>\n';
            console.log("Supplement", supplement);
            // add supplement flies
            for (index = 0; index < supplement.length; index++) {
                zip.file(supplement[index]["originalTarget"]["files"][0]["name"], supplement[index].target.files[0]);
                manifestXML += '<content location="./' + supplement[index]["originalTarget"]["files"][0]["name"] + '" format="https://www.iana.org/assignments/media-types/text/csv" />\n';
            }
            img = zip.folder("simulations");
            img.file("defaultSimulation.R", defaultSimulation);
            manifestXML += '<content location="./simulations/defaultSimulation.R" format="http://purl.org/NET/mediatypes/application/r" />\n';
            manifestXML += '<content location="./sim.sedml" format="http://identifiers.org/combine.specifications/sed-ml" />\n';
            manifestXML += '<content location="./model.sbml" format="http://purl.org/NET/mediatypes/application/sbml+xml" />\n';
            //if workspace exists
            //manifestXML += '<content format="http://purl.org/NET/mediatypes/application/r" location="./workspace.r" />\n'
            //RDFMetadata += '<rdf:Description rdf:about="/workspace.r">\n<dc:type xmlns:dc="http://purl.org/dc/elements/1.1/">workspace</dc:type>\n</rdf:Description>\n';
            //if packages exist
            //manifestXML += '<content format="https://www.iana.org/assignments/media-types/application/json" location="./packages.json" />\n'
            //if readME exists
            //manifestXML += '<content format="http://purl.org/NET/mediatypes/text-xplain" location="./README.txt" />\n'
            //RDFMetadata += '<rdf:Description rdf:about="/README.txt">\n<dc:type xmlns:dc="http://purl.org/dc/elements/1.1/">readme</dc:type>\n</rdf:Description>\n';
            //Close RDF file
            RDFMetadata += '</rdf:RDF>\n';
            zip.file("metadata.rdf", RDFMetadata);
            manifestXML += '<content location="./metadata.rdf" format="http://identifiers.org/combine.specifications/omex-metadata" />\n';
            //Close Manifest file
            manifestXML += '</omexManifest>\n';
            console.log(manifestXML);
            zip.file("manifest.xml", manifestXML);
            console.log("FSKZip", zip);
            /*zip.generateAsync({
                type:"blob",
                mimeType: "application/zip",
                compression: "DEFLATE"})
            .then(function(content) {
                // see FileSaver.js
                console.log("CreateFSK File", content);
            
            
                //saveAs(content, "example.zip");
                return(content);
            
            });*/
            return [2 /*return*/, zip];
        });
    });
}
exports.createFSK = createFSK;
function capitalize(word) {
    console.log("word", word);
    return word.charAt(0).toUpperCase() + word.slice(1);
}
function runFSK(FSKfile, metaData) {
    var _this = this;
    console.log("Run server");
    //conntectServer();
    if (typeof metaData !== 'string') {
        var modelFile;
        var vizFile;
        var parameterFile;
        var piggy;
        console.log("content", FSKfile);
        jszip_1.default.loadAsync(FSKfile).then(function (content) {
            content;
            console.log("contents", content);
            content.files["model.r"].async("string").then(function (Text) {
                modelFile = Text;
                content.files["visualization.r"].async('text').then(function (Next) {
                    vizFile = Next;
                    content.files["simulations/defaultSimulation.R"].async("string").then(function (Last) {
                        parameterFile = Last;
                        console.log("InputFiles", modelFile, vizFile, parameterFile);
                        var modelcode = parameterFile + "\n" + modelFile + "\n" + vizFile;
                        conntectServer(modelcode, "http://localhost:8888", "test-secret").then(function (res1) {
                            console.log("Result", res1);
                            piggy = res1;
                        });
                    });
                });
            });
        });
        return new Promise(function (resolve, reject) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, piggy];
                    case 1:
                        _a.sent();
                        console.log("It is done.", piggy);
                        // Succeed half of the time.
                        if (typeof piggy !== 'undefined') {
                            resolve("SUCCESS");
                        }
                        else {
                            reject("FAILURE");
                        }
                        return [2 /*return*/];
                }
            });
        }); });
    }
    else {
        // Jupyter Anbindung
        var modelFile = "";
        var vizFile = "";
        var parameterFile = "";
        console.log("content", FSKfile);
    }
}
exports.runFSK = runFSK;
function extractFiles(FSK) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            return [2 /*return*/];
        });
    });
}
function createSimulationSEDMLfile(metaData) {
    return metaData;
}
function createModelSBMLfile(metaData) {
    return metaData;
}
function conntectServer(modelcode, jupyterURL, jupyterToken) {
    return __awaiter(this, void 0, void 0, function () {
        var kernelManager, result, msg, serverSettings, kernelOptions, session, future;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    kernelManager = new services_1.KernelManager();
                    msg = {
                        url: jupyterURL
                    };
                    serverSettings = services_1.ServerConnection.makeSettings({
                        baseUrl: msg.url,
                        wsUrl: "ws" + msg.url.slice(4),
                        token: jupyterToken,
                        appUrl: "http://localhost:4200"
                    });
                    kernelOptions = {
                        name: "ir",
                        kernelName: "ir",
                        path: "/",
                        serverSettings: serverSettings
                    };
                    return [4 /*yield*/, services_1.Session.startNew(kernelOptions)];
                case 1:
                    session = _a.sent();
                    future = session.kernel.requestExecute({ code: modelcode });
                    // Handle iopub messages
                    future.onIOPub = function (msg) {
                        console.log("Header", msg);
                        if (msg.header.msg_type === 'display_data') {
                            console.log(msg.content);
                            result = msg.content;
                        }
                    };
                    return [4 /*yield*/, future.done];
                case 2:
                    _a.sent();
                    return [2 /*return*/, result];
            }
        });
    });
}
